"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_1 = require("../shared/fs");
var shared_1 = require("./shared");
function getCosmosConfigPath() {
    var cliArgs = shared_1.getCliArgs();
    // CLI support for --config relative/path/to/cosmos.config.json
    if (typeof cliArgs.config === 'string') {
        if (path_1.default.extname(cliArgs.config) !== '.json') {
            throw new Error("[Cosmos] Invalid config file type: " + cliArgs.config + " (must be .json)");
        }
        var absPath = path_1.default.resolve(shared_1.getCurrentDir(), cliArgs.config);
        if (!fs_1.fileExists(absPath)) {
            throw new Error("[Cosmos] Config not found at path: " + cliArgs.config);
        }
        return absPath;
    }
    // CLI suppport for --root-dir relative/path/project
    var configDir = typeof cliArgs.rootDir === 'string'
        ? shared_1.getRootDirAtPath(cliArgs.rootDir)
        : shared_1.getCurrentDir();
    return path_1.default.join(configDir, 'cosmos.config.json');
}
exports.getCosmosConfigPath = getCosmosConfigPath;
