"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var resolve_from_1 = __importDefault(require("resolve-from"));
var slash_1 = require("../shared/slash");
function resolvePath(rootDir, filePath) {
    // Use to deal with file paths only
    return slash_1.slash(path_1.default.resolve(rootDir, filePath));
}
exports.resolvePath = resolvePath;
function resolveModule(rootDir, moduleId) {
    // Use to deal with file paths and module names interchangeably
    return slash_1.slash(
    // An absolute path is already resolved
    path_1.default.isAbsolute(moduleId)
        ? moduleId
        : resolve_from_1.default.silent(rootDir, moduleId) ||
            // Final attempt: Resolve relative paths that don't either
            // 1. Don't start with ./
            // 2. Don't point to an existing file
            path_1.default.join(rootDir, moduleId));
}
exports.resolveModule = resolveModule;
