"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var yargs_1 = __importDefault(require("yargs"));
var fs_1 = require("../shared/fs");
function getCliArgs() {
    return yargs_1.default.argv;
}
exports.getCliArgs = getCliArgs;
function getCurrentDir() {
    return process.cwd();
}
exports.getCurrentDir = getCurrentDir;
function getRootDirAtPath(dirPath) {
    var absPath = path_1.default.resolve(getCurrentDir(), dirPath);
    if (!fs_1.dirExists(absPath)) {
        throw new Error("[Cosmos] Dir not found at path: " + dirPath);
    }
    return absPath;
}
exports.getRootDirAtPath = getRootDirAtPath;
