"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_1 = require("react-cosmos-shared2/react");
var ErrorCatch = /** @class */ (function (_super) {
    __extends(ErrorCatch, _super);
    function ErrorCatch() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            error: null
        };
        return _this;
    }
    ErrorCatch.prototype.componentDidCatch = function (error, info) {
        this.setState({
            error: error.message + "\n" + info.componentStack
        });
    };
    ErrorCatch.prototype.componentDidUpdate = function (prevProps) {
        // A change in children signifies that the problem that caused the current
        // error might've been solved. If the error persists, it will organically
        // trigger the error state again in the next update
        if (this.state.error &&
            !react_1.areNodesEqual(this.props.children, prevProps.children)) {
            this.setState({
                error: null
            });
        }
    };
    ErrorCatch.prototype.render = function () {
        return this.state.error
            ? this.renderError(this.state.error)
            : this.props.children;
    };
    ErrorCatch.prototype.renderError = function (error) {
        // NOTE: In dev mode this output is overlayed by react-error-overlay,
        // which has greater UI and detail. But the information rendered here is
        // most useful in static exports, where react-error-overlay is missing.
        return (React.createElement(React.Fragment, null,
            React.createElement("p", null,
                React.createElement("strong", null, "Ouch, something wrong!")),
            React.createElement("pre", null, error),
            React.createElement("p", null, "Check console for more info.")));
    };
    return ErrorCatch;
}(React.Component));
exports.ErrorCatch = ErrorCatch;
