"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("./shared");
var alreadyAdded = false;
function addGlobalErrorHandler(rendererId) {
    if (alreadyAdded) {
        return;
    }
    alreadyAdded = true;
    window.addEventListener('error', function () {
        postMessageToParentWindow({
            type: 'rendererError',
            payload: { rendererId: rendererId }
        });
    });
}
exports.addGlobalErrorHandler = addGlobalErrorHandler;
function postMessageToParentWindow(msg) {
    // NOTE: Error messages are not sent from remote renderers, only from
    // iframe preview renderers
    if (shared_1.isInsideCosmosPreviewIframe()) {
        parent.postMessage(msg, '*');
    }
}
