"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_dom_1 = require("react-dom");
var react_cosmos_fixture_1 = require("react-cosmos-fixture");
var shared_1 = require("./shared");
var container_1 = require("./container");
var ErrorCatch_1 = require("./ErrorCatch");
var rendererId_1 = require("./rendererId");
var globalErrorHandler_1 = require("./globalErrorHandler");
var rendererId = rendererId_1.getRendererId();
function mountDomRenderer(_a) {
    var fixtures = _a.fixtures, decorators = _a.decorators, rendererConfig = _a.rendererConfig, onFixtureChange = _a.onFixtureChange;
    globalErrorHandler_1.addGlobalErrorHandler(rendererId);
    react_dom_1.render(React.createElement(react_cosmos_fixture_1.FixtureLoader, { rendererId: rendererId, rendererConnect: getRendererConnect(), fixtures: fixtures, systemDecorators: [ErrorCatch_1.ErrorCatch], userDecorators: decorators, onFixtureChange: onFixtureChange }), container_1.getDomContainer(rendererConfig.containerQuerySelector));
}
exports.mountDomRenderer = mountDomRenderer;
function getRendererConnect() {
    return shared_1.isInsideCosmosPreviewIframe()
        ? react_cosmos_fixture_1.createPostMessageConnect()
        : react_cosmos_fixture_1.createWebSocketsConnect(getWebSocketsUrl());
}
function getWebSocketsUrl() {
    // TODO: Allow user to input URL
    return location.origin;
}
