"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("react-cosmos-shared2/util");
// Renderer ID is remembered to avoid announcing a new renderer when reloading
// the renderer window. Note that each tab has creates a new session and thus
// a new rendererId.
// https://developer.mozilla.org/en-US/docs/Web/API/Window/sessionStorage
function getRendererId() {
    var rendererId = sessionStorage.getItem('cosmosRendererId');
    if (!rendererId) {
        rendererId = util_1.uuid();
        sessionStorage.setItem('cosmosRendererId', rendererId);
    }
    return rendererId;
}
exports.getRendererId = getRendererId;
