"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var query_string_1 = __importDefault(require("query-string"));
var ErrorOverlay = __importStar(require("react-error-overlay"));
var LAUNCH_EDITOR_ENDPOINT = '/_open';
function init() {
    ErrorOverlay.startReportingRuntimeErrors({
        filename: process.env.PUBLIC_URL + '/main.js'
    });
    ErrorOverlay.setEditorHandler(function (errorLocation) {
        return window.fetch(getLaunchEditorUrl(errorLocation));
    });
    setUpBuildErrorReporting();
}
exports.init = init;
function dismiss() {
    ErrorOverlay.dismissRuntimeErrors();
}
exports.dismiss = dismiss;
function getLaunchEditorUrl(errorLocation) {
    return LAUNCH_EDITOR_ENDPOINT + "?" + query_string_1.default.stringify({
        filePath: errorLocation.fileName,
        line: errorLocation.lineNumber || 1,
        column: errorLocation.colNumber || 1
    });
}
function setUpBuildErrorReporting() {
    var clientWindow = window;
    if (clientWindow.__webpack_hot_middleware_reporter__ === undefined) {
        return;
    }
    clientWindow.__webpack_hot_middleware_reporter__.useCustomOverlay({
        showProblems: function (type, obj) {
            if (type !== 'errors') {
                // We might've went from errors -> warnings
                ErrorOverlay.dismissBuildError();
            }
            else {
                ErrorOverlay.reportBuildError(obj[0]);
            }
        },
        clear: function () {
            ErrorOverlay.dismissBuildError();
        }
    });
}
