"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var domRenderer_1 = require("../../../domRenderer");
var errorOverlay_1 = require("./errorOverlay");
function mount() {
    // Use dynamic import to load updated modules upon hot reloading
    var _a = require('./userDeps'), rendererConfig = _a.rendererConfig, fixtures = _a.fixtures, decorators = _a.decorators;
    domRenderer_1.mountDomRenderer({
        rendererConfig: rendererConfig,
        fixtures: fixtures,
        decorators: decorators,
        onFixtureChange: errorOverlay_1.dismissErrorOverlay
    });
}
errorOverlay_1.initErrorOverlay();
mount();
if (module.hot) {
    module.hot.accept('./userDeps', function () {
        // If a previous error has been solved, the error overlay auto-closes nicely.
        // If the error persists, however, the overlay will pop up again on its own
        errorOverlay_1.dismissErrorOverlay();
        mount();
    });
}
