"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var util_promisify_1 = __importDefault(require("util.promisify"));
var webpack_dev_middleware_1 = __importDefault(require("webpack-dev-middleware"));
var webpack_hot_middleware_1 = __importDefault(require("webpack-hot-middleware"));
var config_1 = require("../../config");
var static_1 = require("../../shared/static");
var shared_1 = require("./shared");
var webpack_1 = require("./cosmosConfig/webpack");
var webpackConfig_1 = require("./webpackConfig");
function webpackDevServer(_a) {
    var cosmosConfig = _a.cosmosConfig, expressApp = _a.expressApp;
    return __awaiter(this, void 0, void 0, function () {
        var userWebpack, webpackConfig, staticPath, webpackCompiler, onCompilationDone, wdmInst, hotReload;
        var _this = this;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    userWebpack = shared_1.getWebpack(cosmosConfig.rootDir);
                    if (!userWebpack) {
                        return [2 /*return*/];
                    }
                    webpackConfig = webpackConfig_1.getDevWebpackConfig(cosmosConfig, userWebpack);
                    // Serve static path derived from devServer.contentBase webpack config
                    if (cosmosConfig.staticPath === null) {
                        staticPath = getWebpackStaticPath(webpackConfig);
                        if (staticPath !== null) {
                            static_1.serveStaticDir(expressApp, config_1.resolvePath(cosmosConfig.rootDir, staticPath), cosmosConfig.publicUrl);
                        }
                    }
                    webpackCompiler = userWebpack(webpackConfig);
                    webpackCompiler.hooks.invalid.tap('Cosmos', function (filePath) {
                        var relFilePath = path_1.default.relative(process.cwd(), filePath);
                        console.log('[Cosmos] webpack build invalidated by', relFilePath);
                    });
                    onCompilationDone = new Promise(function (resolve) {
                        webpackCompiler.hooks.done.tap('Cosmos', function () { return resolve(); });
                    });
                    console.log('[Cosmos] Building webpack...');
                    wdmInst = webpack_dev_middleware_1.default(webpackCompiler, {
                        // publicPath is the base path for the webpack assets and has to match
                        // webpack.output.path
                        publicPath: static_1.getRootUrl(cosmosConfig.publicUrl),
                        logLevel: 'warn'
                    });
                    expressApp.use(wdmInst);
                    hotReload = webpack_1.createWebpackCosmosConfig(cosmosConfig).hotReload;
                    if (hotReload) {
                        expressApp.use(webpack_hot_middleware_1.default(webpackCompiler));
                    }
                    return [4 /*yield*/, onCompilationDone];
                case 1:
                    _b.sent();
                    console.log("[Cosmos] All good. Have fun!");
                    return [2 /*return*/, function () { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, util_promisify_1.default(wdmInst.close.bind(wdmInst))()];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); }];
            }
        });
    });
}
exports.webpackDevServer = webpackDevServer;
function getWebpackStaticPath(_a) {
    var devServer = _a.devServer;
    return devServer && typeof devServer.contentBase === 'string'
        ? devServer.contentBase
        : null;
}
