"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("./shared");
var webpackConfig_1 = require("./webpackConfig");
function webpackExport(_a) {
    var cosmosConfig = _a.cosmosConfig;
    return __awaiter(this, void 0, void 0, function () {
        var userWebpack, webpackConfig, err_1, webpackError;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    userWebpack = shared_1.getWebpack(cosmosConfig.rootDir);
                    if (!userWebpack) {
                        return [2 /*return*/];
                    }
                    webpackConfig = webpackConfig_1.getExportWebpackConfig(cosmosConfig, userWebpack);
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, runWebpackCompiler(userWebpack, webpackConfig)];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _b.sent();
                    webpackError = err_1;
                    if (webpackError.webpackErrors) {
                        webpackError.webpackErrors.forEach(function (error) {
                            console.error(error + "\n");
                        });
                    }
                    throw webpackError;
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.webpackExport = webpackExport;
function runWebpackCompiler(userWebpack, webpackConfig) {
    return new Promise(function (resolve, reject) {
        var compiler = userWebpack(webpackConfig);
        compiler.run(function (err, stats) {
            if (err) {
                reject(err);
            }
            else if (stats.hasErrors()) {
                var error = new WebpackCompilationError();
                error.webpackErrors = stats.toJson().errors;
                reject(error);
            }
            else {
                resolve(stats);
            }
        });
    });
}
var WebpackCompilationError = /** @class */ (function (_super) {
    __extends(WebpackCompilationError, _super);
    function WebpackCompilationError() {
        return _super.call(this, 'Webpack errors occurred') || this;
    }
    return WebpackCompilationError;
}(Error));
