"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var shared_1 = require("./shared");
var htmlPlugin_1 = require("./htmlPlugin");
function getExportWebpackConfig(cosmosConfig, userWebpack) {
    var baseWebpackConfig = shared_1.getUserWebpackConfig(cosmosConfig, userWebpack);
    return __assign({}, baseWebpackConfig, { entry: getEntry(), output: getOutput(cosmosConfig), module: __assign({}, baseWebpackConfig.module, { rules: getRules(baseWebpackConfig) }), plugins: getPlugins(cosmosConfig, baseWebpackConfig, userWebpack) });
}
exports.getExportWebpackConfig = getExportWebpackConfig;
function getEntry() {
    // The React devtools hook needs to be imported before any other module that
    // might import React
    var devtoolsHook = shared_1.resolveDomRendererPath('reactDevtoolsHook');
    var clientIndex = shared_1.resolveClientPath('index');
    return [devtoolsHook, clientIndex];
}
function getOutput(_a) {
    var exportPath = _a.exportPath, publicUrl = _a.publicUrl;
    var filename = '[name].js';
    return {
        // Most paths are created using forward slashes regardless of the OS for
        // consistency, but this one needs to have backslashes on Windows!
        path: path_1.default.join(exportPath, publicUrl),
        filename: filename,
        publicPath: publicUrl
    };
}
function getRules(baseWebpackConfig) {
    var existingRules = (baseWebpackConfig.module && baseWebpackConfig.module.rules) || [];
    return existingRules.concat([shared_1.getUserDepsLoaderRule()]);
}
function getPlugins(cosmosConfig, baseWebpackConfig, userWebpack) {
    var existingPlugins = baseWebpackConfig.plugins || [];
    var globalsPlugin = shared_1.getGlobalsPlugin(cosmosConfig, userWebpack, false);
    var noEmitErrorsPlugin = new userWebpack.NoEmitOnErrorsPlugin();
    return htmlPlugin_1.ensureHtmlWebackPlugin(cosmosConfig, existingPlugins.concat([
        globalsPlugin,
        noEmitErrorsPlugin
    ]));
}
