"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var import_from_1 = __importDefault(require("import-from"));
var playgroundHtml_1 = require("../../../shared/playgroundHtml");
var shared_1 = require("./shared");
function ensureHtmlWebackPlugin(_a, plugins) {
    var rootDir = _a.rootDir;
    if (shared_1.hasPlugin(plugins, 'HtmlWebpackPlugin')) {
        return plugins.map(function (plugin) {
            return isHtmlWebpackPlugin(plugin) ? changeHtmlPluginFilename(plugin) : plugin;
        });
    }
    var htmlWebpackPlugin = getHtmlWebpackPlugin(rootDir);
    if (!htmlWebpackPlugin) {
        return plugins;
    }
    return plugins.concat([
        new htmlWebpackPlugin({
            title: 'React Cosmos',
            filename: playgroundHtml_1.RENDERER_FILENAME
        })
    ]);
}
exports.ensureHtmlWebackPlugin = ensureHtmlWebackPlugin;
function getHtmlWebpackPlugin(rootDir) {
    return import_from_1.default.silent(rootDir, 'html-webpack-plugin');
}
exports.getHtmlWebpackPlugin = getHtmlWebpackPlugin;
function isHtmlWebpackPlugin(plugin) {
    return shared_1.isInstanceOfPlugin(plugin, 'HtmlWebpackPlugin');
}
function changeHtmlPluginFilename(htmlPlugin) {
    if (htmlPlugin.options.filename !== 'index.html') {
        return htmlPlugin;
    }
    return new htmlPlugin.constructor(__assign({}, htmlPlugin.options, { filename: playgroundHtml_1.RENDERER_FILENAME }));
}
