"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var static_1 = require("../static");
var playgroundHtml_1 = require("../playgroundHtml");
function createApp(platformType, cosmosConfig) {
    var app = express_1.default();
    var playgroundHtml = playgroundHtml_1.getDevPlaygroundHtml(platformType, cosmosConfig);
    app.get('/', function (req, res) {
        res.send(playgroundHtml);
    });
    app.get('/_playground.js', function (req, res) {
        res.sendFile(require.resolve('react-cosmos-playground2/dist'));
    });
    app.get('/_cosmos.ico', function (req, res) {
        res.sendFile(static_1.getStaticPath('favicon.ico'));
    });
    return app;
}
exports.createApp = createApp;
