/// <reference types="node" />
import http from 'http';
import express from 'express';
import { CosmosConfig } from '../../config';
import { PlatformType } from '../shared';
declare type PluginCleanupCallback = () => unknown;
declare type PluginReturn = void | null | PluginCleanupCallback;
export declare type DevServerPluginArgs = {
    cosmosConfig: CosmosConfig;
    httpServer: http.Server;
    expressApp: express.Express;
};
export declare type DevServerPlugin = (args: DevServerPluginArgs) => PluginReturn | Promise<PluginReturn>;
export declare function startDevServer(platformType: PlatformType, plugins?: DevServerPlugin[]): Promise<() => Promise<void>>;
export {};
