"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// NOTE: This API has been extracted to be easily mocked inside tests
var fs_1 = __importDefault(require("fs"));
function requireModule(modulePath) {
    try {
        return require(modulePath);
    }
    catch (err) {
        return undefined;
    }
}
exports.requireModule = requireModule;
// Better than fs.exists because it works for module paths without an extension
function moduleExists(modulePath) {
    try {
        return require.resolve(modulePath) && true;
    }
    catch (err) {
        return false;
    }
}
exports.moduleExists = moduleExists;
function fileExists(filePath) {
    return fs_1.default.existsSync(filePath) && fs_1.default.lstatSync(filePath).isFile();
}
exports.fileExists = fileExists;
function dirExists(dirPath) {
    return fs_1.default.existsSync(dirPath) && fs_1.default.lstatSync(dirPath).isDirectory();
}
exports.dirExists = dirExists;
