"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var slash_1 = __importDefault(require("slash"));
// Convert Windows backslash paths to slash paths.
// Context: Node uses appropriate path separators based on the platform it runs
// on. Forward slash on Unix and backward slash on Windows.
// So why normalize slashes if Node takes care of this abstraction?
// Because we use globs often. And some implementations only work with forward
// slashes: https://github.com/isaacs/node-glob#windows
// Initial encounter: https://github.com/react-cosmos/react-cosmos/issues/288
// For further study: https://github.com/micromatch/micromatch#backslashes
// Node supports either on Windows, anyway.
// https://nodejs.org/api/path.html#path_path_win32
function slash() {
    var paths = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        paths[_i] = arguments[_i];
    }
    return paths.length > 1 ? slash_1.default(path_1.default.join.apply(path_1.default, paths)) : slash_1.default(paths[0]);
}
exports.slash = slash;
