"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var express_1 = __importDefault(require("express"));
var path_1 = __importDefault(require("path"));
function getStaticPath(relPath) {
    return path_1.default.join(__dirname, 'static', relPath);
}
exports.getStaticPath = getStaticPath;
function getRootUrl(publicUrl) {
    // To enable deploying static exports running from inside a nested path,
    // publicUrl can be set to `./`.
    // (See https://github.com/react-cosmos/react-cosmos/issues/777)
    // But publicUrl is used in for some paths which must begin with `/`:
    // - As publicPath in webpack-dev-middleware
    // - As the Express path for serving static assets
    // These are server-side modules (running in dev server mode) that only
    // respond to incoming paths which begin with the root URL we specify.
    return publicUrl === './' ? '/' : publicUrl;
}
exports.getRootUrl = getRootUrl;
function serveStaticDir(app, staticPath, publicUrl) {
    var relStaticPath = path_1.default.relative(process.cwd(), staticPath);
    console.log("[Cosmos] Serving static files from " + relStaticPath);
    app.use(getRootUrl(publicUrl), express_1.default.static(staticPath, {
        // Ensure loader index (generated by html-webpack-plugin) loads instead
        // of the index.html from staticPath
        index: false
    }));
}
exports.serveStaticDir = serveStaticDir;
