"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var slash_1 = require("../slash");
var findUserModulePaths_1 = require("./findUserModulePaths");
// Warning: Renderer config must be serializable!
function generateUserDepsModule(cosmosConfig, rendererConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var rootDir, fixturesDir, fixtureFileSuffix, globalImports, _a, fixturePaths, decoratorPaths;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    rootDir = cosmosConfig.rootDir, fixturesDir = cosmosConfig.fixturesDir, fixtureFileSuffix = cosmosConfig.fixtureFileSuffix, globalImports = cosmosConfig.globalImports;
                    return [4 /*yield*/, findUserModulePaths_1.findUserModulePaths({
                            rootDir: rootDir,
                            fixturesDir: fixturesDir,
                            fixtureFileSuffix: fixtureFileSuffix
                        })];
                case 1:
                    _a = _b.sent(), fixturePaths = _a.fixturePaths, decoratorPaths = _a.decoratorPaths;
                    return [2 /*return*/, getCompiledTemplate({
                            globalImports: genGlobalRequires(globalImports),
                            rendererConfig: stringifyRendererConfig(rendererConfig),
                            fixtures: genRequireMap(fixturePaths, rootDir),
                            decorators: genRequireMap(decoratorPaths, rootDir)
                        })];
            }
        });
    });
}
exports.generateUserDepsModule = generateUserDepsModule;
function genGlobalRequires(paths) {
    if (paths.length === 0) {
        return '';
    }
    return [
        '',
        '// Keeping global imports here is superior to making them bundle entry points',
        '// because this way they become hot-reloadable'
    ].concat(paths.map(function (importPath) { return "import '" + importPath + "';"; }), [
        ''
    ]).join("\n");
}
function genRequireMap(paths, rootDir) {
    if (paths.length === 0) {
        return '{}';
    }
    var requireRows = paths.map(function (p) {
        var relPath = slash_1.slash(path_1.default.relative(rootDir, p));
        return "\n  '" + relPath + "': require('" + p + "').default";
    });
    return "{" + requireRows.join(', ') + "\n}";
}
function stringifyRendererConfig(rendererConfig) {
    return JSON.stringify(rendererConfig, null, 2);
}
function getCompiledTemplate(_a) {
    var globalImports = _a.globalImports, rendererConfig = _a.rendererConfig, fixtures = _a.fixtures, decorators = _a.decorators;
    return "// This file is automatically generated by Cosmos\n" + globalImports + "\nexport const rendererConfig = " + rendererConfig + ";\nexport const fixtures = " + fixtures + ";\nexport const decorators = " + decorators + ";\n";
}
