"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("../shared");
// NODE: These can be made configurable if a proper need arises
var FIXTURE_PATTERNS = [
    '**/<fixturesDir>/**/*.{js,jsx,ts,tsx}',
    '**/*.<fixtureFileSuffix>.{js,jsx,ts,tsx}'
];
var DECORATOR_PATTERNS = ['**/cosmos.decorator.{js,jsx,ts,tsx}'];
var IGNORE_PATTERNS = ['**/node_modules/**', '**/dist/**'];
function getFixturePatterns(fixturesDir, fixtureFileSuffix) {
    return FIXTURE_PATTERNS.map(function (pattern) {
        return shared_1.replaceKeys(pattern, {
            '<fixturesDir>': fixturesDir,
            '<fixtureFileSuffix>': fixtureFileSuffix
        });
    });
}
exports.getFixturePatterns = getFixturePatterns;
function getDecoratorPatterns() {
    return DECORATOR_PATTERNS;
}
exports.getDecoratorPatterns = getDecoratorPatterns;
function getIgnorePatterns() {
    return IGNORE_PATTERNS;
}
exports.getIgnorePatterns = getIgnorePatterns;
